# Ogre::SharedPtr< T > Class Template Reference

Reference-counted shared pointer, used for objects where implicit destruction is required. More...

`#include <OgreSharedPtr.h>`

List of all members.

## Public Member Functions

OGRE_AUTO_SHARED_MUTEX | SharedPtr ()
| Constructor, does not initialise the SharedPtr.
| SharedPtr (T *rep)
| SharedPtr (const SharedPtr &r)
SharedPtr & | operator= (const SharedPtr &r)
virtual | ~SharedPtr ()
T & | operator * () const
T * | operator-> () const
T * | get () const
void | bind (T *rep)
| Binds rep to the SharedPtr.
bool | unique () const
unsigned int | useCount () const
unsigned int * | useCountPointer () const
T * | getPointer () const
bool | isNull (void) const
void | setNull (void)

## Protected Member Functions

void | release (void)
virtual void | destroy (void)

## Protected Attributes

T * | pRep
unsigned int * | pUseCount

## Detailed Description

### template<class T>
class Ogre::SharedPtr< T >

Reference-counted shared pointer, used for objects where implicit destruction is required.

Remarks:
  This is a standard shared pointer implementation which uses a reference count to work out when to delete the object. OGRE does not use this class very often, because it is usually more efficient to make the destruction of objects more intentional (in blocks, say). However in some cases you really cannot tell how many people are using an object, and this approach is worthwhile (e.g. ControllerValue)

  If OGRE_THREAD_SUPPORT is defined to be 1, use of this class is thread-safe.

Definition at line 44 of file OgreSharedPtr.h.

## Constructor & Destructor Documentation

template<class T>
OGRE_AUTO_SHARED_MUTEX Ogre::SharedPtr< T >::SharedPtr | ( |  | ) |

Constructor, does not initialise the SharedPtr.

Remarks:
  Dangerous! You have to call bind() before using the SharedPtr.

Definition at line 54 of file OgreSharedPtr.h.

template<class T>
Ogre::SharedPtr< T >::SharedPtr | ( | T * | rep | ) | `[explicit]`

| Definition at line 55 of file OgreSharedPtr.h.

template<class T>
Ogre::SharedPtr< T >::SharedPtr | ( | const SharedPtr< T > & | r | ) |

| Definition at line 59 of file OgreSharedPtr.h.

template<class T>
virtual Ogre::SharedPtr< T >::~SharedPtr | ( |  | ) | `[virtual]`

| Definition at line 87 of file OgreSharedPtr.h.

## Member Function Documentation

template<class T>
void Ogre::SharedPtr< T >::bind | ( | T * | rep | ) |

Binds rep to the SharedPtr.

Remarks:
  Assumes that the SharedPtr is uninitialised!

Definition at line 100 of file OgreSharedPtr.h.

template<class T>
virtual void Ogre::SharedPtr< T >::destroy | ( | void |  | ) | `[protected, virtual]`

| Reimplemented in Ogre::MeshPtr. Definition at line 146 of file OgreSharedPtr.h. Referenced by Ogre::SharedPtr< Skeleton >::release().

template<class T>
T* Ogre::SharedPtr< T >::get | ( |  | ) | const

| Definition at line 94 of file OgreSharedPtr.h. Referenced by Ogre::operator!=(), and Ogre::operator==().

template<class T>
T* Ogre::SharedPtr< T >::getPointer | ( |  | ) | const

Definition at line 112 of file OgreSharedPtr.h.

Referenced by Ogre::BspLevelPtr::BspLevelPtr(), Ogre::D3D9GpuProgramPtr::D3D9GpuProgramPtr(), Ogre::D3D9TexturePtr::D3D9TexturePtr(), Ogre::D3DTexturePtr::D3DTexturePtr(), Ogre::FontPtr::FontPtr(), Ogre::GLTexturePtr::GLTexturePtr(), Ogre::HighLevelGpuProgramPtr::HighLevelGpuProgramPtr(), Ogre::MaterialPtr::MaterialPtr(), Ogre::TexturePtr::operator=(), Ogre::SkeletonPtr::operator=(), Ogre::PatchMeshPtr::operator=(), Ogre::MaterialPtr::operator=(), Ogre::HighLevelGpuProgramPtr::operator=(), Ogre::GpuProgramPtr::operator=(), Ogre::GLTexturePtr::operator=(), Ogre::FontPtr::operator=(), Ogre::D3D9TexturePtr::operator=(), Ogre::D3D9GpuProgramPtr::operator=(), Ogre::D3DTexturePtr::operator=(), Ogre::BspLevelPtr::operator=(), Ogre::PatchMeshPtr::PatchMeshPtr(), Ogre::SkeletonPtr::SkeletonPtr(), and Ogre::TexturePtr::TexturePtr().

template<class T>
bool Ogre::SharedPtr< T >::isNull | ( | void |  | ) | const

| Definition at line 114 of file OgreSharedPtr.h. Referenced by Ogre::ResourceManager::resourceExists().

template<class T>
T& Ogre::SharedPtr< T >::operator * | ( |  | ) | const

| Definition at line 92 of file OgreSharedPtr.h.

template<class T>
T* Ogre::SharedPtr< T >::operator-> | ( |  | ) | const

| Definition at line 93 of file OgreSharedPtr.h.

template<class T>
SharedPtr& Ogre::SharedPtr< T >::operator= | ( | const SharedPtr< T > & | r | ) |

| Definition at line 72 of file OgreSharedPtr.h.

template<class T>
void Ogre::SharedPtr< T >::release | ( | void |  | ) | `[protected]`

| Definition at line 129 of file OgreSharedPtr.h. Referenced by Ogre::SharedPtr< Skeleton >::operator=(), Ogre::SharedPtr< Skeleton >::setNull(), and Ogre::SharedPtr< Skeleton >::~SharedPtr().

template<class T>
void Ogre::SharedPtr< T >::setNull | ( | void |  | ) |

| Definition at line 116 of file OgreSharedPtr.h.

template<class T>
bool Ogre::SharedPtr< T >::unique | ( |  | ) | const

| Definition at line 108 of file OgreSharedPtr.h.

template<class T>
unsigned int Ogre::SharedPtr< T >::useCount | ( |  | ) | const

| Definition at line 109 of file OgreSharedPtr.h.

template<class T>
unsigned int* Ogre::SharedPtr< T >::useCountPointer | ( |  | ) | const

Definition at line 110 of file OgreSharedPtr.h.

Referenced by Ogre::BspLevelPtr::BspLevelPtr(), Ogre::D3D9GpuProgramPtr::D3D9GpuProgramPtr(), Ogre::D3D9TexturePtr::D3D9TexturePtr(), Ogre::D3DTexturePtr::D3DTexturePtr(), Ogre::FontPtr::FontPtr(), Ogre::GLTexturePtr::GLTexturePtr(), Ogre::HighLevelGpuProgramPtr::HighLevelGpuProgramPtr(), Ogre::MaterialPtr::MaterialPtr(), Ogre::TexturePtr::operator=(), Ogre::SkeletonPtr::operator=(), Ogre::PatchMeshPtr::operator=(), Ogre::MaterialPtr::operator=(), Ogre::HighLevelGpuProgramPtr::operator=(), Ogre::GpuProgramPtr::operator=(), Ogre::GLTexturePtr::operator=(), Ogre::FontPtr::operator=(), Ogre::D3D9TexturePtr::operator=(), Ogre::D3D9GpuProgramPtr::operator=(), Ogre::D3DTexturePtr::operator=(), Ogre::BspLevelPtr::operator=(), Ogre::PatchMeshPtr::PatchMeshPtr(), Ogre::SkeletonPtr::SkeletonPtr(), and Ogre::TexturePtr::TexturePtr().

## Member Data Documentation

template<class T>
T* Ogre::SharedPtr< T >::pRep `[protected]`

| Definition at line 46 of file OgreSharedPtr.h. Referenced by Ogre::SharedPtr< Skeleton >::operator=(), and Ogre::SharedPtr< Skeleton >::SharedPtr().

template<class T>
unsigned int* Ogre::SharedPtr< T >::pUseCount `[protected]`

| Definition at line 47 of file OgreSharedPtr.h. Referenced by Ogre::SharedPtr< Skeleton >::operator=(), and Ogre::SharedPtr< Skeleton >::SharedPtr().

The documentation for this class was generated from the following file:

- OgreSharedPtr.h

Copyright © 2000-2005 by The OGRE Team
Last modified Sun Nov 20 12:39:48 2005